using System;
using System.Data.SqlClient;
using System.Data;

namespace PrikladyZive59
{
	/// <summary>
	/// Priklad na ulozeni stavu transakce
	/// </summary>
	internal class SavePointExam
	{
		internal static void Run()
		{
			SqlConnection lConn = new SqlConnection(@"data source='dellak\sql1';initial catalog='zive'; integrated security='sspi'");
			SqlCommand lComm1 = lConn.CreateCommand();
			SqlCommand lComm2 = lConn.CreateCommand();
			//vytvoreni prikazu pro vlozeni zaznamu do databaze
			lComm1.CommandText = "insert into employee (FirstName, SurName, BirthDate) values ('Prvni', 'Zaznam', @BirthDate)";
			lComm2.CommandText = "insert into employee (FirstName, SurName, BirthDate) values ('Druhy', 'Zaznam', @BirthDate)";

			lComm1.Parameters.Add("@BirthDate", SqlDbType.DateTime).Value = DateTime.Now;
			lComm2.Parameters.Add("@BirthDate", SqlDbType.DateTime).Value = DateTime.Now;

			SqlTransaction lTrans = null;
			try
			{
				lConn.Open();
				//zahajeni transakce
				lTrans = lConn.BeginTransaction();
				lComm1.Transaction = lTrans;
				lComm2.Transaction = lTrans;

				lComm1.ExecuteNonQuery();
				//vytvoreni savepointu
				lTrans.Save("point");
				lComm2.ExecuteNonQuery();
				//navraceni stavu databaze do stavu v jakem byla pri 
				//vytvoreni savepointu
				lTrans.Rollback("point");
				//potvrzeni transakce - databazi ovlivni pouze prvni dotaz
				lTrans.Commit();
				Console.WriteLine("Transakce byla ukoncena");
			}
			catch(Exception ex)
			{
				if (lTrans != null)
				{
					try
					{
						lTrans.Rollback();
					}
					catch(Exception ex2)
					{
						Console.WriteLine("Chyba pri rollbacku : {0}", ex2);
					}
				}
				Console.WriteLine(ex);
			}
			finally
			{
				if (lConn != null)
				{
					lConn.Close();
				}
			}
		}
	}
}
